## mingw-w64-python-pyarrow-21.0.0-1.src.tar.zst

=== cpp/examples/parquet/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

add_executable(parquet-low-level-example low_level_api/reader_writer.cc)
add_executable(parquet-low-level-example2 low_level_api/reader_writer2.cc)
add_executable(parquet-arrow-example parquet_arrow/reader_writer.cc)
add_executable(parquet-stream-api-example parquet_stream_api/stream_reader_writer.cc)
target_include_directories(parquet-low-level-example PRIVATE low_level_api/)
target_include_directories(parquet-low-level-example2 PRIVATE low_level_api/)

# The variables in these files are for illustration purposes
set(PARQUET_EXAMPLES_WARNING_SUPPRESSIONS low_level_api/reader_writer.cc
                                          low_level_api/reader_writer2.cc)

if(PARQUET_REQUIRE_ENCRYPTION)
  add_executable(parquet-encryption-example low_level_api/encryption_reader_writer.cc)
  add_executable(parquet-encryption-example-all-crypto-options
                 low_level_api/encryption_reader_writer_all_crypto_options.cc)
  target_include_directories(parquet-encryption-example PRIVATE low_level_api/)
  target_include_directories(parquet-encryption-example-all-crypto-options
                             PRIVATE low_level_api/)

  set(PARQUET_EXAMPLES_WARNING_SUPPRESSIONS
      ${PARQUET_EXAMPLES_WARNING_SUPPRESSIONS} low_level_api/encryption_reader_writer.cc
      low_level_api/encryption_reader_writer_all_crypto_options.cc)

endif()

if(UNIX)
  foreach(FILE ${PARQUET_EXAMPLES_WARNING_SUPPRESSIONS})
    set_property(SOURCE ${FILE}
                 APPEND_STRING
                 PROPERTY COMPILE_FLAGS "-Wno-unused-variable")
  endforeach()
endif()

# Prefer shared linkage but use static if shared build is deactivated
if(ARROW_BUILD_SHARED)
  set(PARQUET_EXAMPLE_LINK_LIBS parquet_shared)
else()
  set(PARQUET_EXAMPLE_LINK_LIBS parquet_static)
endif()

target_link_libraries(parquet-arrow-example ${PARQUET_EXAMPLE_LINK_LIBS})
target_link_libraries(parquet-low-level-example ${PARQUET_EXAMPLE_LINK_LIBS})
target_link_libraries(parquet-low-level-example2 ${PARQUET_EXAMPLE_LINK_LIBS})
target_link_libraries(parquet-stream-api-example ${PARQUET_EXAMPLE_LINK_LIBS})

if(PARQUET_REQUIRE_ENCRYPTION)
  target_link_libraries(parquet-encryption-example ${PARQUET_EXAMPLE_LINK_LIBS})
  target_link_libraries(parquet-encryption-example-all-crypto-options
                        ${PARQUET_EXAMPLE_LINK_LIBS})
endif()

add_dependencies(parquet
                 parquet-low-level-example
                 parquet-low-level-example2
                 parquet-arrow-example
                 parquet-stream-api-example)

if(PARQUET_REQUIRE_ENCRYPTION)
  add_dependencies(parquet parquet-encryption-example
                   parquet-encryption-example-all-crypto-options)
endif()

=== cpp/src/arrow/engine/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

add_custom_target(arrow_substrait)

arrow_install_all_headers("arrow/engine")

# If libarrow_substrait.a is only built, "pkg-config --cflags --libs
# arrow-substrait" outputs build flags for static linking not shared
# linking. ARROW_SUBSTRAIT_PC_* except ARROW_SUBSTRAIT_PC_*_PRIVATE are for
# the static linking case.
if(NOT ARROW_BUILD_SHARED AND ARROW_BUILD_STATIC)
  string(APPEND ARROW_SUBSTRAIT_PC_CFLAGS "${ARROW_SUBSTRAIT_PC_CFLAGS_PRIVATE}")
  set(ARROW_SUBSTRAIT_PC_CFLAGS_PRIVATE "")
endif()

set(ARROW_SUBSTRAIT_SRCS
    substrait/expression_internal.cc
    substrait/extended_expression_internal.cc
    substrait/extension_set.cc
    substrait/extension_types.cc
    substrait/options.cc
    substrait/plan_internal.cc
    substrait/relation_internal.cc
    substrait/serde.cc
    substrait/test_plan_builder.cc
    substrait/type_internal.cc
    substrait/util_internal.cc
    substrait/util.cc)

add_arrow_lib(arrow_substrait
              CMAKE_PACKAGE_NAME
              ArrowSubstrait
              PKG_CONFIG_NAME
              arrow-substrait
              OUTPUTS
              ARROW_SUBSTRAIT_LIBRARIES
              SOURCES
              ${ARROW_SUBSTRAIT_SRCS}
              SHARED_LINK_FLAGS
              ${ARROW_VERSION_SCRIPT_FLAGS} # Defined in cpp/arrow/CMakeLists.txt
              SHARED_LINK_LIBS
              arrow_dataset_shared
              substrait
              SHARED_INSTALL_INTERFACE_LIBS
              ArrowDataset::arrow_dataset_shared
              STATIC_LINK_LIBS
              arrow_dataset_static
              substrait
              STATIC_INSTALL_INTERFACE_LIBS
              ArrowDataset::arrow_dataset_static
              PRIVATE_INCLUDES
              ${SUBSTRAIT_INCLUDES})

foreach(LIB_TARGET ${ARROW_SUBSTRAIT_LIBRARIES})
  target_compile_definitions(${LIB_TARGET} PRIVATE ARROW_ENGINE_EXPORTING)
endforeach()

set(ARROW_SUBSTRAIT_TEST_LINK_LIBS ${ARROW_SUBSTRAIT_LINK_lIBS} ${ARROW_TEST_LINK_LIBS})
if(ARROW_TEST_LINKAGE STREQUAL "static")
  list(APPEND ARROW_SUBSTRAIT_TEST_LINK_LIBS arrow_substrait_static
       arrow_substrait_static)
else()
  list(APPEND ARROW_SUBSTRAIT_TEST_LINK_LIBS arrow_substrait_shared)
endif()

add_arrow_test(substrait_test
               SOURCES
               substrait/ext_test.cc
               substrait/function_test.cc
               substrait/serde_test.cc
               substrait/protobuf_test_util.cc
               substrait/test_util.cc
               EXTRA_LINK_LIBS
               ${ARROW_SUBSTRAIT_TEST_LINK_LIBS}
               arrow_compute_testing
               PREFIX
               "arrow-substrait"
               LABELS
               "arrow_substrait")

add_subdirectory(substrait)

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=pyarrow
pkgbase=mingw-w64-python-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-python-${_realname}")
pkgver=21.0.0
pkgrel=1
pkgdesc="Columnar in-memory analytics layer for big data — Python module (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://arrow.apache.org/"
msys2_repository_url="https://github.com/apache/arrow"
msys2_references=(
  'archlinux: arrow'
  "cpe: cpe:/a:apache:arrow"
  'purl: pkg:pypi/pyarrow'
)
license=('spdx:Apache-2.0')
depends=(
  "${MINGW_PACKAGE_PREFIX}-arrow"
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-python-numpy"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-clang"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-cython"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-python-build"
  "${MINGW_PACKAGE_PREFIX}-python-installer"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools-scm"
  "${MINGW_PACKAGE_PREFIX}-llvm"
)
options=('!strip')
source=("https://www.apache.org/dyn/closer.lua?action=download&filename=arrow/arrow-${pkgver}/apache-arrow-${pkgver}.tar.gz"{,.asc})
sha256sums=('5d3f8db7e72fb9f65f4785b7a1634522e8d8e9657a445af53d4a34a3849857b5'
            'SKIP')
validpgpkeys=('A2AC7132B5DA7C273A7A147665F4A8CA9769ECD7')

build() {
  export SETUPTOOLS_SCM_PRETEND_VERSION=${pkgver}

  cd "apache-arrow-${pkgver}/python"

  PYARROW_CMAKE_GENERATOR="Ninja" \
  PYARROW_CMAKE_OPTIONS="-DARROW_SIMD_LEVEL=NONE -DARROW_RUNTIME_SIMD_LEVEL=MAX" \
  PYARROW_WITH_DATASET=1 \
  PYARROW_WITH_FLIGHT=1 \
  PYARROW_WITH_HDFS=1 \
  PYARROW_WITH_PARQUET=1 \
  PYARROW_WITH_PARQUET_ENCRYPTION=1 \
  ${MINGW_PREFIX}/bin/python -m build --wheel --skip-dependency-check --no-isolation
}

package() {
  cd "apache-arrow-${pkgver}/python"

  MSYS2_ARG_CONV_EXCL="--prefix=" \
    ${MINGW_PREFIX}/bin/python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" dist/*.whl
}
